net1 = inceptionv3;
net2=inceptionresnetv2;
net3=densenet201;
%%
net4=alexnet;
%%
imageFolder = fullfile('C:\Users\Talha\Downloads\Compressed\Dataset_BUSI\Dataset_BUSI_with_GT\codes\','final_Segmented');

%%
imds = imageDatastore(imageFolder, 'LabelSource', 'foldernames', 'IncludeSubfolders',true);
%%
[imdsTrain,imdsValidation] = splitEachLabel(imds,0.7,'randomized');

%%
inputSize1 = net1.Layers(1).InputSize
inputSize2 = net2.Layers(1).InputSize
inputSize3 = net3.Layers(1).InputSize
inputSize4 = net4.Layers(1).InputSize
%%

augimdsTrain1 = augmentedImageDatastore(inputSize1,imdsTrain,'ColorPreprocessing', 'gray2rgb');
augimdsTest1 = augmentedImageDatastore(inputSize1,imdsValidation,'ColorPreprocessing', 'gray2rgb');
augimdsTrain2 = augmentedImageDatastore(inputSize3,imdsTrain,'ColorPreprocessing', 'gray2rgb');
augimdsTest2 = augmentedImageDatastore(inputSize3,imdsValidation,'ColorPreprocessing', 'gray2rgb');
augimdsTrain3 = augmentedImageDatastore(inputSize4,imdsTrain,'ColorPreprocessing', 'gray2rgb');
augimdsTest3 = augmentedImageDatastore(inputSize4,imdsValidation,'ColorPreprocessing', 'gray2rgb');
%%
layer = 'predictions';
featuresTrain1 = activations(net1,augimdsTrain1,layer,'OutputAs','rows');
featuresTest1 = activations(net1,augimdsTest1,layer,'OutputAs','rows');
%%
layer = 'predictions';
featuresTrain2 = activations(net2,augimdsTrain1,layer,'OutputAs','rows');
featuresTest2 = activations(net2,augimdsTest1,layer,'OutputAs','rows');
%%
layer = 'fc1000';
featuresTrain3 = activations(net3,augimdsTrain2,layer,'OutputAs','rows');
featuresTest3 = activations(net3,augimdsTest2,layer,'OutputAs','rows');
%%
layer = 'fc8';
featuresTrain4 = activations(net4,augimdsTrain3,layer,'OutputAs','rows');
featuresTest4 = activations(net4,augimdsTest3,layer,'OutputAs','rows');

%%
YTrain = imdsTrain.Labels;
YTest = imdsValidation.Labels;
%%
mdl1 = fitcecoc(featuresTrain1,YTrain);

YPred1 = predict(mdl1,featuresTest1);

accuracy = mean(YPred1 == YTest)

plotconfusion(YTest,YPred1)
title('Confusion Matrix of InceptionV3')
%%
mdl2 = fitcecoc(featuresTrain2,YTrain);

YPred2 = predict(mdl2,featuresTest2);


accuracy = mean(YPred2 == YTest)
plotconfusion(YTest,YPred2)
title('Confusion Matrix of InceptionResnetV2')
%%
mdl3 = fitcecoc(featuresTrain3,YTrain);

YPred3 = predict(mdl3,featuresTest3);


accuracy = mean(YPred3 == YTest)
plotconfusion(YTest,YPred3)
title('Confusion Matrix of Dense201')
%%
mdl4 = fitcecoc(featuresTrain4,YTrain);

YPred4 = predict(mdl4,featuresTest4);

accuracy = mean(YPred4 == YTest)
plotconfusion(YTest,YPred4)
title('Confusion Matrix of AlexNet')
%%
Train1=[featuresTrain1,featuresTrain2];
Train2=[featuresTrain3,featuresTrain4];
Test1=[featuresTest1,featuresTest2];
Test2=[featuresTest3,featuresTest4];
[trainZ,testZ] = ccaFuse(Train1,Train2,Test1,Test2, 'concat');
%% fusion using cca
mdl5 = fitcecoc(trainZ,YTrain);
YPred5 = predict(mdl5,testZ);
accuracy = mean(YPred5 == YTest)
%%
 for i=1:length(imdsTrain.Labels)
%    
     I=readimage(imdsTrain,i);
     size=sizeinmm(I);
     Trainsize(i)=size;
 end
%%
for i=1:length(imdsValidation.Labels)
%    
     I=readimage(imdsValidation,i);
     size=sizeinmm(I);
     Testsize(i)=size;
end
 %%
 mdl6 = fitcecoc(Trainsize',YTrain);

YPred6 = predict(mdl6,Testsize');

accuracy = mean(YPred6 == YTest)
%%
plotconfusion(YTest,YPred6)
title('Confusion Matrix of Size')
%%
%%
 for i=1:length(imdsTrain.Labels)
%    
     I=readimage(imdsTrain,i);
     stats=regionprops(I);
     %Trainsize(i)=size;
     Tstats(i)=stats.Area;
 end
%%
for i=1:length(imdsValidation.Labels)
%    
     I=readimage(imdsValidation,i);
     stats=regionprops(I);
     Vstats(i)=stats.Area;
end
%%
YTrain = imdsTrain.Labels;
YTest = imdsValidation.Labels;
mdl7 = fitcecoc(Tstats',YTrain);

YPred7 = predict(mdl7,Vstats');

accuracy = mean(YPred7 == YTest)
%%
plotconfusion(YTest,YPred7)
title('Confusion Matrix of Area')